
#include "density.h"




#include <stdlib.h>

#include "config.h"
#include "agent.h"
#include "ip.h"
#include "node.h"
#include <random.h>

int hdr_den::offset_;

/*
 *This code implements TCL hooks for the density packet header (DensityHeader), the agent class (DensityClass),
 *the density partner (DensityPartner). The last entity is in charge of intercepting broadcast packets arriving
 *at the current node toward the Node entry point.
 */
class DensityHeaderClass : public PacketHeaderClass {
public:
	DensityHeaderClass() : PacketHeaderClass ("PacketHeader/DEN", sizeof(hdr_den)) {
			bind_offset(&hdr_den::offset_);
		}
	}
class_denhdr;


static class DensityClass : public TclClass {
public:
  DensityClass() : TclClass("Agent/Density") {}
  TclObject* create(int argc , const char*const* argv){
      assert(argc == 5);
      return (new DensityAgent((nsaddr_t) atoi(argv[4])));
	  }
  virtual void bind();
  virtual int method (int argc, const char*const* argv);
} class_density;


static class DensityPartnerClass : public TclClass {
public:
        DensityPartnerClass() : TclClass("DensityPartner") {}
        TclObject* create(int, const char*const*) {
                return (new DensityPartner());
        }
} class_densitypartner;



//==================================================================================================/
//=========================STATIC VARIABLE BINDINGS=================================================/
//==================================================================================================/

void DensityClass::bind()
{
	TclClass::bind();
	add_method("disc_delay");
	add_method("part_adv_interval");
  add_method("part_adv_delay");
  add_method("limit");
	add_method("dist_rep_interval");
	add_method("dist_req_delay");
	add_method("election_accuracy");
	add_method("delegation_interval");
	add_method("forwarding_prob");
	add_method("dist_reply_prob");
	add_method("max_best");
  add_method("hello_period");
  add_method("hello_delay");
  add_method("check_hello_period");
 }

int DensityClass::method(int ac, const char*const* av)
{
	Tcl& tcl = Tcl::instance();
	char out[100];
	int argc = ac - 2;
	const char*const* argv = av + 2;

	if (argc == 2) {
		if (strcmp(argv[1], "disc_delay") == 0) {
			tcl.resultf("%d", DensityAgent::disc_delay_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "part_adv_interval") == 0) {
			tcl.resultf("%d", DensityAgent::part_adv_interval_ );
			return (TCL_OK);
		} else if (strcmp(argv[1], "part_adv_delay") == 0) {
			tcl.resultf("%d",
				    DensityAgent::part_adv_delay_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "limit") == 0) {
			tcl.resultf("%d", DensityAgent::limit_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "dist_rep_interval") == 0) {
			tcl.resultf("%d", DensityAgent::dist_rep_interval_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "dist_req_delay") == 0) {
			tcl.resultf("%d", DensityAgent::dist_req_delay_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "election_accuracy") == 0) {
			tcl.resultf("%f", DensityAgent::election_accuracy_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "delegation_interval") == 0) {
			tcl.resultf("%d", DensityAgent::delegation_interval_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "forwarding_prob") == 0) {
			tcl.resultf("%f", DensityAgent::forwarding_prob_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "dist_reply_prob") == 0) {
			tcl.resultf("%f", DensityAgent::dist_reply_prob_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "max_best") == 0) {
			tcl.resultf("%d", DensityAgent::max_best_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "hello_period") == 0) {
			tcl.resultf("%f", DensityAgent::hello_period_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "hello_delay") == 0) {
			tcl.resultf("%f", DensityAgent::hello_delay_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "check_hello_period") == 0) {
			tcl.resultf("%f", DensityAgent::check_hello_period_);
			return (TCL_OK);
		}
	}
	else if (argc==3) {
	        if(strcmp(argv[1],"disc_delay")==0) {
		         DensityAgent::disc_delay_=atoi(argv[2]);
			 return (TCL_OK);
		         }
		else if(strcmp(argv[1],"part_adv_interval")==0) {
		         DensityAgent::part_adv_interval_=atoi(argv[2]);
			 return (TCL_OK);
			 }
		else if(strcmp(argv[1],"part_adv_delay")==0) {
		         DensityAgent::part_adv_delay_=atoi(argv[2]);
			 return (TCL_OK);
			 }
		else if(strcmp(argv[1],"limit")==0) {
		         DensityAgent::limit_=atoi(argv[2]);
			 return (TCL_OK);
			 }
		else if(strcmp(argv[1],"dist_rep_interval")==0) {
			DensityAgent::dist_rep_interval_=atoi(argv[2]);
			return (TCL_OK);
		}
		else if(strcmp(argv[1],"dist_req_delay")==0) {
			DensityAgent::dist_req_delay_=atoi(argv[2]);
			return (TCL_OK);
		}
		else if(strcmp(argv[1],"election_accuracy")==0) {
			DensityAgent::election_accuracy_=atof(argv[2]);
			return (TCL_OK);
		}
		else if(strcmp(argv[1],"delegation_interval")==0) {
			DensityAgent::delegation_interval_=atoi(argv[2]);
			return (TCL_OK);
		}
		else if(strcmp(argv[1],"forwarding_prob")==0) {
			DensityAgent::forwarding_prob_=atof(argv[2]);
			return (TCL_OK);
		}
		else if(strcmp(argv[1],"dist_reply_prob")==0) {
			DensityAgent::dist_reply_prob_=atof(argv[2]);
			return (TCL_OK);
		}
		else if(strcmp(argv[1],"max_best")==0) {
			DensityAgent::max_best_=atoi(argv[2]);
			return (TCL_OK);
		}
    else if(strcmp(argv[1],"hello_period")==0) {
			DensityAgent::hello_period_=atof(argv[2]);
			return (TCL_OK);
		}
    else if(strcmp(argv[1],"hello_delay")==0) {
			DensityAgent::hello_delay_=atof(argv[2]);
			return (TCL_OK);
		}
    else if(strcmp(argv[1],"check_hello_period")==0) {
			DensityAgent::check_hello_period_=atof(argv[2]);
			return (TCL_OK);
		}
	}

	return TclClass::method(ac, av);
}

int DensityAgent::disc_delay_; 
int DensityAgent::part_adv_delay_; 
int DensityAgent::part_adv_interval_; 
int DensityAgent::limit_; 
int DensityAgent::dist_rep_interval_;
int DensityAgent::dist_req_delay_;
float DensityAgent::election_accuracy_;
int DensityAgent::delegation_interval_;
float DensityAgent::forwarding_prob_;
float DensityAgent::dist_reply_prob_;
int DensityAgent::max_best_;
float DensityAgent::hello_period_;
float DensityAgent::hello_delay_;
float DensityAgent::check_hello_period_;

//=================================================================================================/
//=========================END OF STATIC VARIABLE BINDINGS=========================================/
//=================================================================================================/


//========================CONSTRUCTOR AND COMMAND FOR DENSITY AGENT===============================/

DensityAgent::DensityAgent(nsaddr_t id) : Agent(PT_DEN), part_(0), state_(0), counter_(0), disc_timer_(this),
                                          ngbEnNum_(0), initiator_(0), part_adv_timer_(this),from_(-1),
					  last_to_(0), dist_rep_timer_(this), dist_fw_timer_(this), deleg_timer_(this), send_hello_timer_(this),
            check_neighbor_timer_(this), del_(0)
{
  int j=0;
  nid_=id;
  current_IN_=5789; //A number not identifying any node
  forwarders_num_=0;
  bind("packetSize_", &size_);
}



int DensityAgent::command(int argc, const char*const* argv)
{

  if (argc == 2) {

        /*
         *The initiator receives this command to start the Boundary identification protocol
         */
        if (strcmp(argv[1], "start") == 0) {
          start();
          return (TCL_OK);
        }

        /*
         *This command starts the Manager Election protocol
         */
        if (strcmp(argv[1], "calcDist") == 0) {
          current_IN_=nid_;
          distance_=0;
          send_calc_req();
          return (TCL_OK);
        }

        /*
         *This command starts the Hello packets delivery on the node that receives it.
         *Moreover it schedules the Check Neighbors background routine.
         */
        if(strcmp(argv[1],"startHello") == 0) {
          sendHello();
          check_neighbor_timer_.resched(DensityAgent::check_hello_period_);
          return (TCL_OK);
        }

        /*
         *This command is used during the Boundary Maintenance Protocol test (Figure 6 of the IWDC04 paper)
         *to count the number of current dense MANET participants.
         */

        if (strcmp(argv[1],"count")==0) {
         char out[100];
         Tcl& tcl=Tcl::instance();
         if(part_==1)
    	      {
             sprintf(out,"test1 %d %f", nid_, Scheduler::instance().clock());
             tcl.eval(out);
            }
         return (TCL_OK);
        }
       
  }

  /*
   *If the command hasn't been processed by DensityAgent()::command,
   *call the command() function for the base class
   */
  return (Agent::command(argc, argv));
}


//================================END OF CONSTRUCTOR AND COMMAND=============================//



//===============================RECEIVER AND DISPATCHER=====================================//
void DensityAgent::recv(Packet* pkt, Handler*)
{
  // Access the Ping header for the received packet:
  hdr_den* hdr = HDR_DEN(pkt);
  
  switch (hdr->type)
  	{
     /*BOUNDARIES IDENTIFICATION MESSAGES*/
     case DENSITY_DISC:
         recvDensityDiscovery(pkt);
         Packet::free(pkt);
	   break;
     
	   /*MANAGER ELECTION MESSAGES*/
     /*Farthest nodes identification*/
  	 case DENSITY_DST_REQ:
         recvDistReq(pkt);
         Packet::free(pkt);
     break;
     case DENSITY_DST_REP:
         recvDistRep(pkt);
         Packet::free(pkt);
     break;

     /*The current node has been delegate for farthest node evaluation,
      *to decide its manager suitability*/     
	   case DENSITY_DELEG_CALC:
		     current_IN_=nid_;
         distance_=0;
		     send_calc_req();
		     delegation_packet_=pkt;
		 break;

     /*BOUNDARIES MAINTENANCE MESSAGES*/
     case DENSITY_HELLO:
         recvHello(pkt);
         Packet::free(pkt);
     break;


	}

  }


  //========================ACTION DISPATCHER WHEN TIMERS FIRE====================//

  /*This method is called when the discovery timeout expires*/
  void DensityAgent::timeout (int t)
  {
   Packet* pkt;
   int next, j=0,k=0,s=0;
   hdr_den* hdr;
   char out[100];
   Tcl& tcl = Tcl::instance();
   bool trovato=false;
   int table[NODENUM];
   switch (t) {

        /*BOUNDARIES IDENTIFICATION PROTOCOL*/
        case DISC:
	          discover();
	      break;
	      case ADV:
            advertise();
        break;
         
        /*MANAGER ELECTION PROTOCOL*/
        /*Farthest nodes identification*/
        /*When this timer fires, the node has to rebroadcast the DIST_REQ packet*/
        case DST_FORWARDING:
	          //Next line provides for a probabilistic forwarding
	          //if(Random::uniform(1)<(float)(DensityAgent::forwarding_prob_/sqrt(dist_rec_num_)))
	       	          send_calc_req();
	      break;
        
        /*When this timer fires, the node replies to the current IN*/
        case DST_REP:
	          //if(Random::uniform(1)<DensityAgent::dist_reply_prob_/dist_rec_num_)
                    sprintf(out,"reply %d %d %d", nid_, first_forwarder_,current_IN_);
                    tcl.eval(out);
                    distance_reply(distance_, nid_);
	      break;


	     /*DELEGATION OF ELECTION*/
	      case DELEGATION:             
             delegate();
        break;

       
 }

}

/*================================================================================================
 *                                 BOUNDARIES IDENTIFICATION PROTOCOL
 *================================================================================================*/

/*
 *This method represent the start procedure. This is exploited by the initiator to send
 *the first broadcast packet
 */
void DensityAgent::start()
{ 
   // Create a new packet
   Packet* pkt = BCastPacket();
   // Access the Density header for the new packet
   hdr_den_disc* hdr = HDR_DEN_DISC(pkt);
   // Set the header inner fields
   // The id of the source
   hdr->disc_srcid = 0;
   // Packet Type
   hdr->disc_type=DENSITY_DISC;
   // Send the packet
   send(pkt, 0);
   // Set initiator state fields
   // The node has broadcasted its identity
   state_=1;
   //This node is the initiator
   initiator_=1;
   // When the part_adv_timer_ fires the node declares if it is willing to
   //participate or not to the hotspot
   part_adv_timer_.resched(DensityAgent::part_adv_interval_+Random::uniform(DensityAgent::part_adv_delay_));
}

 
/*
 *This method is called when the node receives a Density Discovery Messge from the initiator
 *for the identification of the dense MANET boundaries
 */
void DensityAgent::recvDensityDiscovery(Packet* pkt)
{
    char out[100];
    Tcl& tcl=Tcl::instance();
    struct hdr_den_disc* hdr= HDR_DEN_DISC(pkt);
    sprintf( out, "%s recv %d %d ", name(), nid_,  hdr->disc_srcid);
		tcl.eval(out);
    counter_++;
    if(state_==0)
			//In this case the node should broadcast its identifier
			{
			 disc_timer_.resched(Random::uniform(DensityAgent::disc_delay_));
       state_=1;
			} 
}
      
/*
 *Nodes disclose their identity to neighbors
 */
void DensityAgent::discover()
{
	  state_=1;
	  Packet* pkt=BCastPacket();
	  //Access the Density header for the new packet
		hdr_den_disc* hdr = HDR_DEN_DISC(pkt);
		//Now the problem is to fill hdr_den (header density) fields:
		//first we have to retrieve node's ID
		hdr->disc_srcid = nid_;
		//Packet Type
		hdr->disc_type=DENSITY_DISC;
		// Send the packet
		send(pkt, 0);
		// When the part_adv_timer_ fires the node declares if it is willing to
      		//participate or not to the hotspot
		part_adv_timer_.resched(DensityAgent::part_adv_interval_+Random::uniform(DensityAgent::part_adv_delay_));
}

/*
 *This method advertises the user whether the node participate to the dense MANET or not
 */
void DensityAgent::advertise()
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  if (counter_>=DensityAgent::limit_|| initiator_)
			{
       part_=1;        
			 sprintf(out, "%s ipart %d", name(), 1);
      }
  else{
       part_=0;        
		   sprintf(out, "%s ipart %d", name(), 0);
			}
	tcl.eval(out);
}   

/*================================================================================================
 *                                 MANAGER ELECTION PROTOCOL
 *================================================================================================*/

/*=================================FARTHEST NODES IDENTIFICATION==================================*/



/*
 *This method broadcasts Farthest nodes identification packets
 */
void DensityAgent::send_calc_req()
  {
      // Create a new broadcast packet
      Packet* pkt=BCastPacket();
      // Access the Density header for the new packet
      hdr_den_dst_req* hdr = HDR_DEN_DST_REQ(pkt);
      // Set the header inner fields
      // The id of the source
      hdr->dist_req_srcid = nid_;
      //The current queror
      hdr->dist_req_IN=current_IN_;
      // Packet Type
      hdr->dist_req_type=DENSITY_DST_REQ;
      //The hop number
      hdr->dist_req_nHops=distance_;
      // Send the packet
      send(pkt, 0);
  }


/*
 *Nodes located on dense MANET boundaries reply to the current IN.
 *This same method is used by intermediate nodes to forward distance replies.
 *Actually nodes forward the reply to the first node that forwarded the Distance
 *Calculation Request message
 */
void DensityAgent::distance_reply(int nHops, int srcid)
  {
      //Da togliere
      char out[100];
      Tcl& tcl=Tcl::instance();

      Packet* pkt=allocpkt();
       //Access the ip and cmn headers
	    hdr_ip* hdrip= hdr_ip::access(pkt); 
      //hdr_cmn* hdrc= hdr_cmn::access(pkt);
	    //Prepare IP and COMMON HEADER
	    //hdrc->next_hop_ = first_forwarder_;
      //hdrc->addr_type_ = NS_AF_INET;
      hdrip->daddr() = first_forwarder_;
      hdrip->dport()=300;
      //Access the Density header for the new packet
	    hdr_den_dst_rep* hdr = HDR_DEN_DST_REP(pkt);
	    //Distance in hop of the current node from the source
    	hdr->dist_rep_nHops =nHops;
	    //Set the source id of the pacekt
	    hdr->dist_rep_srcid=srcid;
	    //I am the forwarder node
	    hdr->dist_rep_reply_fw=nid_;
      sprintf( out, "out3 %d %d %d", hdr->dist_rep_reply_fw,first_forwarder_, hdr->dist_rep_srcid);
      tcl.eval(out);
	    //Packet Type
	    hdr->dist_rep_type=DENSITY_DST_REP;
      //The current IN
      hdr->dist_rep_IN=current_IN_;
      // Send the packet
	    send(pkt, 0);
  }


/*
 *This method is called when a node receive a Distance Calculation Request message from a neighbor.
 *In this case it should check whether a Reply is needed (if the node is belongs to network bounds)
 *or not.
 */
void DensityAgent::recvDistReq(Packet*  pkt)
{
    //Da togliere
      char out[100];
      Tcl& tcl=Tcl::instance();
    struct hdr_den_dst_req *hdr = HDR_DEN_DST_REQ(pkt);
    /*The node considers the message only if it participates to the dense MANET*/
    if(part_==1){
                 /*If this is the first request the node receives, it has to evaluate*/
                 if (hdr->dist_req_IN!=current_IN_ )
		                 {
		                  //Reset the number of "distance packet" received
		                  dist_rec_num_=1;
                			//The last forwarder of this packet
                			first_forwarder_=hdr->dist_req_srcid;
                      //
                      //if(nid_==141 || nid_ ==61)
                      sprintf( out, "out4 %d %d %d", nid_,first_forwarder_, hdr->dist_req_srcid);
                      tcl.eval(out);
                      //The source queror
                			current_IN_=hdr->dist_req_IN;
                			//My distance from the current queror
                			distance_= hdr->dist_req_nHops+1;
                			/*Start the reply timer. If this expires before the node has received
                       *a DIST_REQ from a farther node, it replies to the current IN*/
                      dist_rep_timer_.resched(DensityAgent::dist_rep_interval_+Random::uniform(3));
                			//Start the forwarding timer
                			dist_fw_timer_.resched(DensityAgent::dist_req_delay_+Random::uniform(1));
                		 }
            		else if (hdr->dist_req_nHops >= distance_+1)
            		     {
                      sprintf(out, "interrupt %d %d",nid_, hdr->dist_req_srcid);
                      tcl.eval(out);
                      if(dist_rep_timer_.status()==TIMER_PENDING)
            				       dist_rep_timer_.cancel();
            		     }
		            else {dist_rec_num_++;}
                }//End if part==1
}

/*
 *This method is called when a node (either a forwarder or the current IN) receives a DENSITY REPLY
 *message from a farther node. If it is the current IN it records a new entry in its Forwarding Neighbor
 *list.
 */
void DensityAgent::recvDistRep(Packet* pkt)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  struct hdr_den_dst_rep *hdr = HDR_DEN_DST_REP(pkt);
  
  if(hdr->dist_rep_IN!=nid_)
			{
       sprintf(out, "out6 %d %d", nid_, hdr->dist_rep_srcid);
       tcl.eval(out);
       //I am not the current IN, thus I have to forward the message
       distance_reply(hdr->dist_rep_nHops, hdr->dist_rep_srcid);
			}
	else{
       //I am the current IN, thus the farthest node detection has ended
	     sprintf( out, "out %d %d ", hdr->dist_rep_srcid,  hdr->dist_rep_nHops);
			 tcl.eval(out);
			 sprintf( out, "%s reply %d ", name(),  hdr->dist_rep_reply_fw);
			 tcl.eval(out);
			 forwarders_[forwarders_num_]=hdr->dist_rep_reply_fw;
			 forwarders_hops_[forwarders_num_]=hdr->dist_rep_nHops;
			 forwarders_num_++;
       if(del_!=1) deleg_timer_.resched(DensityAgent::delegation_interval_);
		  }
}

/*==================================================================================================
 *==================================================================================================
 *                            DELEGATION LOGIC                                                      *
 *==================================================================================================
 *==================================================================================================*/

/*
 *This method compares current IN value and known IN values to decide if the exploration need to be
 *continued or not
 */ 
void DensityAgent::delegate()
{
 char out[100];
 Tcl& tcl=Tcl::instance();
 sprintf(out, "%s expl",name());
 tcl.eval(out);
 int next;

 del_=1;
    
 /*Evaluate current IN neighbors belonging to FwN*/
 set_FwN();

 //IF I AM NOT THE FIRST IN
 if(delegation_packet_!=NULL )
	 {
	  hdr_den_deleg_calc* hdr=HDR_DEN_DELEG_CALC(delegation_packet_);
    int bestNum=0, worstVal=0, bestVal=0, bestNode=-1;
	  if(INvalue_<= ((float)(hdr->worst_val*DensityAgent::election_accuracy_))
	       		                   || INvalue_==hdr->worst_val/2 || INvalue_==(hdr->worst_val+1)/2)
	       		    {
			            sprintf(out, "%s end %d",name(), INvalue_);
	       		      tcl.eval(out);
        			  }

    else if (INvalue_ < (hdr->best_val))
                {
                 delegate_lessThanBest(hdr);
                }

    else if(INvalue_>hdr->best_val)
                {
                 delegate_higherThanBest(hdr);
                }

    else if(INvalue_ == hdr->best_val)
                {
                 delegate_equalBest(hdr);
                }
    Packet::free(delegation_packet_);
  } 

//I AM THE FIRST IN  
else 
 {
    delegate_first();
 }  

}

/*
 *Next 3 methods are invoked when the current IN value is less than current best IN value (i.e. the
 *node improves the current best solution), when current IN value is higher than the current best IN value
 *(i.e. the node is worse than the current best), or when current IN value equals the current best.
 */
 
void DensityAgent::delegate_lessThanBest(hdr_den_deleg_calc* old_hdr)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  int next;

  int explored[NODENUM];
  int explored_num;
  int unexplored[NODENUM];
  int unexplored_num;
  
  /*Initialize the counter of best solutions in a row*/
  int bestNum=1;
  int bestVal=INvalue_;
  int bestNode=nid_;
  int worstVal=old_hdr->worst_val;

  /*Put all Explored nodes (those contained in the old header and the current IN) to explored list*/
  explored_num=createExplored(old_hdr, explored);

  //Erase explored nodes from unexplored list
  unexplored_num=createUnExplored(unexplored, fwN_, fwN_num_, explored, explored_num);

  //If there not exists unexplored nodes, exit
  if(unexplored_num==0)
         {
            sprintf(out, "%s end %d",name(), INvalue_);
  	        tcl.eval(out);
         }
  //Else delegate the next node
  else
         {
            /*Else choose the next delegate node (one random node belonging to unexplored)*/
            next=deleg_next(unexplored_num,unexplored); 
            delegate(next, bestVal, bestNode, bestNum, worstVal,explored, explored_num, unexplored, unexplored_num);
         }

}

void DensityAgent::delegate_higherThanBest(hdr_den_deleg_calc* old_hdr)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  int next;
  /**/
  int explored[NODENUM];
  int explored_num;
  int unexplored[NODENUM];
  int unexplored_num;
  int bestVal=old_hdr->best_val;
  int bestNode=old_hdr->best_node;
  int bestNum=old_hdr->best_num;
  int worstVal;

  /*Initialize the explored table*/
  explored_num=createExplored(old_hdr, explored);

  /*Create the Unexplored list by deleting explored entries (in this case, my entry)
   *from the old Unexplored list*/
  unexplored_num=createUnExplored(unexplored, old_hdr->unexplored, old_hdr->unexplored_num, explored, explored_num);

  /*If the current solution is worst than current worst, substitute it*/
  if(INvalue_ > old_hdr->worst_val)
         {
            worstVal=INvalue_;
         }
  else worstVal=old_hdr->worst_val;

  /*Discard the my_fronteer list and choose the next explored node from unexplored*/
  //If there not exists unexplored nodes, exit
  if(unexplored_num==0)
         {
            sprintf(out, "$den_(%d) end %d",old_hdr->best_node, old_hdr->best_val);
             tcl.eval(out);
         }

  else
         {
            /*Else choose the next delegate node (one random node belonging to unexplored)*/
            next=deleg_next(unexplored_num,unexplored);
            delegate(next, bestVal, bestNode, bestNum, worstVal,explored, explored_num, unexplored, unexplored_num);
         }
}

void DensityAgent::delegate_equalBest(hdr_den_deleg_calc* old_hdr)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  int next;

  int explored[NODENUM];
  int explored_num;
  int unexplored[NODENUM];
  int unexplored_num;
  int bestNum=old_hdr->best_num;
  bestNum++;
  int bestNode=nid_;
  int bestVal=old_hdr->best_val;
  int worstVal=old_hdr->worst_val;

  int temp_num;
  int temp[NODENUM];
  
  /*Put the current node in explored*/
  explored_num=createExplored(old_hdr,explored);

  /*Merge my_frontier with unexplored nodes*/
  temp_num=merge(temp,fwN_,fwN_num_, old_hdr->unexplored, old_hdr->unexplored_num);

  //Erase explored nodes from unexplored list
  unexplored_num=createUnExplored(unexplored, temp, temp_num, explored, explored_num);

  //If there not exists unexplored nodes, exit
  if(unexplored_num==0 || bestNum==DensityAgent::max_best_)
         {
            sprintf(out, "$den_(%d) end %d",nid_, old_hdr->best_val);
    	       tcl.eval(out);
         }
  //Else delegate the next node
  else
         {
            /*Else choose the next delegate node (one random node belonging to unexplored)*/
            next=deleg_next(unexplored_num,unexplored);
            delegate(next, bestVal, bestNode, bestNum, worstVal,explored, explored_num, unexplored, unexplored_num);
         }
}

/*
 *This methods initializes Unexplored list (UnN), Explored list and best/worst values parameters
 *for the first IN
 */
void DensityAgent::delegate_first()
{
  int next;
  /**/
  int explored[NODENUM];
  int explored_num;
  int unexplored[NODENUM];
  int unexplored_num;
  int bestNum=1;
  int bestNode=nid_;
  int bestVal=INvalue_;
  int worstVal=INvalue_;

  /*Explored nodes initialization*/
  explored[0]=nid_;
  explored_num=1;

  /*Unexplored node list initialization*/
  unexplored_num=createUnExplored(unexplored, fwN_, fwN_num_, explored, explored_num);
  
  /*Else choose the next delegate node (one random node belonging to unexplored)*/
  next=deleg_next(unexplored_num, unexplored);
  delegate(next, bestVal, bestNode, bestNum, worstVal,explored, explored_num, unexplored, unexplored_num);

}

/*======================================================================================================
 *======================================================================================================
 *======================================================================================================*/


/*===================================NEXT IN DELEGATION===========================================*/

/*
 *In this method, the current IN initializes the header of the delegation packet, with parameters values.
 */  
void DensityAgent::delegate(int next, int bestVal, int bestNode, int bestNum,int worstVal, int* explored,
                                        int explored_num, int* unexplored, int unexplored_num)
{
  int k=0;
	Packet* pkt=allocpkt();
	//Access the ip, cmn and density headers
	hdr_ip* hdrip= hdr_ip::access(pkt);
  hdr_cmn* hdrc= hdr_cmn::access(pkt);
	hdr_den_deleg_calc* hdr_new= HDR_DEN_DELEG_CALC(pkt);
	//Prepare IP and COMMON HEADER
	hdrc->next_hop_ = next;
  hdrc->addr_type_ = NS_AF_INET;
  hdrip->daddr() = next;
  hdrip->dport()=300;
	//Copy the extended fronteer to the new packet
	for (k=0;k<unexplored_num;k++)
  		{
  		 hdr_new->unexplored[k]=unexplored[k];
  		}
	hdr_new->unexplored_num=unexplored_num;
	//Copy the explored nodes
	for (k=0;k<explored_num;k++)
  		{
  		 hdr_new->explored[k]=explored[k];
  		}
	hdr_new->explored_num=explored_num;
	//The number of best solutions explored in a raw
	hdr_new->best_num=bestNum;
	//The source of the packet
	hdr_new->deleg_srcid=nid_;
	//Packet Type
	hdr_new->deleg_type=DENSITY_DELEG_CALC;
	//Update header values
	hdr_new->best_val=bestVal;
	hdr_new->best_node=bestNode;
	hdr_new->worst_val=worstVal;
	// Send the packet
	send(pkt, 0);
 }

/*
 *Choose a random current IN's neighbor as the next IN
 */
int DensityAgent::deleg_next (int num, int list[])
{
   //Random::seed(78);
   float x=Random::uniform(num-0.01);
   return list[(int)x];
}

/*==================================MANAGER ELECTION HELPERS======================================*/

/*
 *This method puts the Current IN and old header Explored Nodes in an Explored nodes array 
 */
int DensityAgent::createExplored (hdr_den_deleg_calc* hdr, int* explored)
{
 int j=0;
 for(j=0; j<hdr->explored_num;j++)
      {
       explored[j]=hdr->explored[j];
      }
 explored[j]=nid_;
 return j+1;
}

/*
 *This procedure erases explored nodes from Unexplored List (UnN)
 *of the current packet header
 */
int DensityAgent::createUnExplored(int* unexplored, int* source, int source_num, int*explored, int explored_num)
{
 int k=0,j=0,s=0;
 bool trovato=true;
 while (j<source_num)
       {
        trovato=false;
        for(k=0;k<explored_num && !trovato;k++)
     					{
      					if(explored[k]==source[j])
           						{
            						trovato=true;
                      }
             	}
        if(trovato==false)
              {
               unexplored[s]=source[j];
               s++;
              }
        j++;
       }
 return s;
}

/*
 *This method merges Unexplored Nodes List (UnN) and  Forwarder Nodes List (fwN)
 */
int DensityAgent::merge(int* temp, int* front, int front_num, int* unexplored, int unexplored_num)
{
  int k=0,j=0,s=0;
  bool yet=false, trovato=false;

  for(k=0;k<front_num;k++)
     {
       for(j=0;j<unexplored_num;j++)
  	      {
 	         if(front[k]==unexplored[j])  yet=true;
 	        }
       if(yet==false)
  	      {
 	        temp[s]=front[k];
 	        s++;
 	        }
     yet=false;
    }

  for(j=0;j<unexplored_num;j++)
    {
     temp[s]=unexplored[j];
     s++;
    }
  return s;
}


/*
 *This procedure selects from the all forwarders (that forwarded messages from boundary nodes),
 *the ones that forwarded messages from farthest nodes
 */
void DensityAgent::set_FwN()
{
   int i,cMax=0,j=0,k=0;
   bool trovato=false;
   for (i=0;i<forwarders_num_;i++)
   	      {
	          if(forwarders_hops_[i]>cMax) cMax=forwarders_hops_[i];
	        }
   INvalue_=cMax;
   for(i=0;i<forwarders_num_;i++)
   	      {
           //Check which forwarders belong to my_front
           for(k=0;k<fwN_num_;k++)
	 	             if(forwarders_[i]==fwN_[k]) trovato=true;
           //If they are forwarders for cMax nodes, add them to my_front
	         if(forwarders_hops_[i]==cMax && trovato==false)
	 	           {
		            fwN_[fwN_num_]=forwarders_[i];
                fwN_num_++;
               }
	         trovato=false;
	        }
}



 


/*======================================================================================================
 *                                BOUNDARIES MAINTENANCE                                               *
 *=====================================================================================================*/

/*
 *This method only sends a new Hello message and reschedules the Hello Period timer
 */
 
void DensityAgent::sendHello()
{
    // Create a new packet
    Packet* pkt = BCastPacket();
    // Access the Density header for the new packet
    hdr_den_hello* hdr = HDR_DEN_HELLO(pkt);
    hdr->hello_type = DENSITY_HELLO;
    hdr->hello_srcid = nid_;
    float rit,x,y,k;
    char out[100];
    Tcl& tcl = Tcl::instance();
    sprintf (out, "outSendHello %d", nid_);
    tcl.eval(out);
    // Send the packet
    send(pkt, 0);
    x=DensityAgent::hello_period_;
    y=Random::uniform();
    k=DensityAgent::hello_delay_;
    rit=x+y*k;
    //Reschedule send hello
    send_hello_timer_.resched(rit);
}

/*
 *This method, called upon the reception of an Hello packet, updates the entry in the current Neighbors
 *table or inserts new records in that table if the sender was previously unseen.
 */
void DensityAgent::recvHello(Packet* pkt) {

    hdr_den_hello* hdr=HDR_DEN_HELLO(pkt);
    int snd=hdr->hello_srcid;
    NeighborEntry nb;
    float x;
    char out[100];
    Tcl& tcl = Tcl::instance();
    float time=Scheduler::instance().clock();

    nb = nb_lookup(snd);
    if(nb.id == -1)
          {
           nb_insert(snd);
           /*A new node is in this node visibility*/
           if (neighbors_num_>=limit_ && part_==0)
             {
              part_=1;
              sprintf(out, "%s ipart2 %d %f", name(), 1, Scheduler::instance().clock());
              tcl.eval(out);

             
              //Reschedule timers
              //Schedule send hello
              x=DensityAgent::hello_period_+Random::uniform()*DensityAgent::hello_delay_;
              send_hello_timer_.resched(x);
              //Schedule check neighbor timer
              check_neighbor_timer_.resched(DensityAgent::check_hello_period_);
             }          
         } //IF
   else
          {
           nb_update(nb.id, Scheduler::instance().clock()+ DensityAgent::check_hello_period_*2);
                          
          }

}

/*
 *This method checks whether all neighbors array entries are still valid or not.
 *It purges all timed-out Neighbor Entries.
 */
void DensityAgent::nb_purge() {
      char out[100];
      Tcl& tcl = Tcl::instance();
      NeighborEntry nb ;
      double now = Scheduler::instance().clock();
      int curr=0;
      if(neighbors_num_>0) nb = neighbors_[0];
      for(curr=0;curr<neighbors_num_;) {
         nb=neighbors_[curr];
         if(nb.expire <= now) {
           nb_delete(nb.id);
           sprintf (out, "outDelHello %d %d", nid_,nb.id);
           tcl.eval(out);
           }
         else curr++;
       }
      //The node abandoned the network
      if(neighbors_num_<DensityAgent::limit_ && part_==1)
       {
         part_=0;
         sprintf(out, "%s ipart2 %d %f", name(), 0, Scheduler::instance().clock());
         tcl.eval(out);        
       }
      check_neighbor_timer_.resched(DensityAgent::check_hello_period_);
 }


/*===================================BOUNDARIES MAINTENANCE HELPERS=============================*/
/**
 *This method inspects the Neighbor table to check whether the Neighbor identified by id
 *is present or not
 */
NeighborEntry DensityAgent::nb_lookup(int id) {
int curr=0;
NeighborEntry nb;
nb.id=-1;
for(curr=0;curr<neighbors_num_;curr++)
  {
   nb = neighbors_[curr];
   if(nb.id==id) break;
   else nb.id=-1;
   }    
return nb;
}

/*
 *This method inserts a new entry (of neighbor id) in the current Neighbors list
 */
void  DensityAgent::nb_insert(int id) {
char out[100];
Tcl& tcl = Tcl::instance();
NeighborEntry nb ;
nb.id=id;
nb.expire = Scheduler::instance().clock()+ DensityAgent::check_hello_period_*2;
                //(1.5 * ALLOWED_HELLO_LOSS * HELLO_INTERVAL);
neighbors_[neighbors_num_]=nb;
neighbors_num_++;
sprintf (out, "outHello %d %d", nid_,nb.id);
tcl.eval(out);
}

/*
 *This method update the Neighbors table expiration time of the entry associated
 *to the passed node identifier (id) to the passed value (timer)
 */
void DensityAgent::nb_update(int id, double timer) {
   int curr=0;
   NeighborEntry nb;
   for(curr=0;curr<neighbors_num_;curr++)
        {
         nb = neighbors_[curr];
         if(nb.id==id) neighbors_[curr].expire=timer;
        }
}

/*
 *Called when we receive decide that a Neighbor is no longer reachable,
 *i.e. when it stops sending Hello packets.
 */
void  DensityAgent::nb_delete(int id)
{
    int curr=0, curr2=0;
    for(curr=0;curr<neighbors_num_;curr++)
          {
           NeighborEntry nb = neighbors_[curr];
           if(nb.id==id) break;
          }
    curr2=curr;
    for(++curr;curr<neighbors_num_;curr2++, curr++)
          {
           neighbors_[curr2]=neighbors_[curr];
          }
    neighbors_num_--;
}




  /*=============================================================================================*/
  /*===============================================UTILITIES=====================================*/
  /*=============================================================================================*/


  //Functions that prepares a broadcast packet
  Packet* DensityAgent::BCastPacket()
  {
      // Create a new packet
      Packet* pkt = allocpkt();
      // Access the IP and common headers for the new packet
      hdr_ip* hdrip= hdr_ip::access(pkt);
      hdr_cmn* hdrc= hdr_cmn::access(pkt);
      // Send in Broadcast to all neighbors
      hdrc->next_hop_ = IP_BROADCAST;
      hdrc->addr_type_ = NS_AF_INET;
      hdrip->daddr() = IP_BROADCAST;
      hdrip->dport()=300;
      return (pkt);
  }



  

/*=========================================================================================================*/
/*==============                                 DENSITY PARTNER                  =========================*/
/*=========================================================================================================*/


/*
 *Add Density Partner class to manage broadcast messages: this is fundamental stuff
 */
  DensityPartner::DensityPartner() : Connector(), densityagent_(1),mask_(0xffffffff),
        shift_(8)
    {
        bind("addr_", (int*)&(here_.addr_));
        bind("port_", (int*)&(here_.port_));
        bind("shift_", &shift_);
        bind("mask_", &mask_);
    }

/*
 *The Density Partner receives packets directly from the Link Layer and forwards them to the Node Entry.
 *If packets are BROADCASTed the Density Partner changes 255.255.255.255 with the address of the current
 *node. This seems a good way to let nodes receive local broadcast that alternatively are discarded
 *by the routing protocol.
 */
void DensityPartner::recv(Packet* p, Handler *h)
{
        hdr_ip* hdr = hdr_ip::access(p);
	hdr_cmn *hdrc = hdr_cmn::access(p);

	if ( hdrc->ptype() == PT_DEN )
          {
           if (densityagent_ == 1)
                   {
	                  if (((u_int32_t)hdr->daddr()) == IP_BROADCAST)
                           {
		                        hdr->daddr() = here_.addr_;
	                         }
	                 }
           else {
	               /* if densityagent is not installed, drop the packet */
	               drop (p);
	               return;
                }
	        }
  target_->recv(p,h);
}


int DensityPartner::command(int argc, const char*const* argv)
{
  if (argc == 3)
     {
	    if (strcmp (argv[1], "set-densityagent") == 0)
          {
	         densityagent_ = atoi(argv[2]);
	         return (TCL_OK);
	        }
     }
 return Connector::command(argc, argv);
}


 /*=========================================================================================================*/
 /*==============                                 DENSITY TIMER                   ==========================*/
 /*=========================================================================================================*/

void DiscoveryTimer::expire(Event *) {
  a_->timeout(DISC);
}

/*=========================================================================================================*/
/*==============                               ADVERTISE TIMER                   ==========================*/
/*=========================================================================================================*/

void PartAdvTimer::expire(Event *) {
  a_->timeout(ADV);
}

/*=========================================================================================================*/
/*==============                        DISTANCE REPLY    TIMER                   =========================*/
/*=========================================================================================================*/

void DistanceRepTimer::expire(Event *) {
  a_->timeout(DST_REP);
}

/*=========================================================================================================*/
/*==============                        DISTANCE FORWARDING TIMER                 =========================*/
/*=========================================================================================================*/

void DistanceFwTimer::expire(Event *) {
  a_->timeout(DST_FORWARDING);
}

/*=========================================================================================================*/
/*==============                        DELEGATION TIMER                 =========================*/
/*=========================================================================================================*/

void DelegationTimer::expire(Event *) {
  a_->timeout(DELEGATION);
}

/*=========================================================================================================*/
/*==============                        SEND_HELLO TIMER                 =========================*/
/*=========================================================================================================*/


void SendHelloTimer::expire(Event*) {
   a_->sendHello();
}

/*=========================================================================================================*/
/*==============                        CHECK_NEIGHBOR TIMER                 =========================*/
/*=========================================================================================================*/
void CheckNeighborTimer::expire(Event*) {
  a_->nb_purge();
}




