/*
 *This file contains the neighbors hosting table and utility operations over neighbors
 */

#ifndef __neighbors__
#define __neighbors__

/*
 *The following struct represent a Neighbor entry with needed fields
 */
struct NeighborEntry {

       int id;
       int neigh_num;
       int verified;
       double expire;      

       };

/*Returns an ordered version of table1*/  
void order (NeighborEntry* table1, int dimension);

/*Check whether a NeighborEntry belongs to a Neighbor array or not*/
int belongs(NeighborEntry* table, int dim, NeighborEntry en);

/*========= > OPERATOR OVERLOAD FUNCTION =========================*/
bool operator < (NeighborEntry& e1, NeighborEntry& e2); 

/*========= == OPERATOR OVERLOAD FUNCTION=========================*/
bool operator == (NeighborEntry& e1, NeighborEntry& e2);



#endif
